import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URLDecoder;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;

/**
 * Verwandelt die Ausgabe des c++-Programms in eine Datei, in der die
 * Koordinaten der Autos pro Zeitschritt aufgelistet sind.
 * 
 * @author Miriam von Heereman, Marcel Ellermann, Martin Poppinga
 * 
 */
public class GrafischeDarstellung
{
	static private Vector<Node> _nodes = new Vector<Node>();
	static private ArrayList<Street> _streets = new ArrayList<Street>();
	static private String _pfad;
	static private String _ort;

	public static void main(String[] args) throws IOException
	{
		int inputNodes = 0;
		String inputMap = "";
		for(int i = 0; i < args.length; i++)
		{
			if(args[i].equals("-n"))
			{
				if(i+1<args.length)
				{
					inputNodes = Integer.parseInt(args[i+1]);
				}
			}
			if(args[i].equals("-f"))
			{
				if(i+1<args.length)
				{
					inputMap = args[i+1];
				}
			}
		}
		CoordTransformer _transformer = new CoordTransformer(inputNodes, inputMap);
		if(_transformer.Initialize())
		{
			//CoordTransformer loaded successfully
			while(_transformer.processNext())
			{
				//process next time stamp as long as we can.
				//can add further constrains here later to only extract specific timesteps
			}
		}
		//all work done, close filestreams and cleanup object
		_transformer.Close();
	}
}
