import java.util.ArrayList;

/**
 * Strae mit Straenid und eine Liste von Knoten, die jeweils den Abstand zum 0
 * Knoten haben.
 * 
 * @author Miriam von Heereman, Marcel Ellermann, Martin Poppinga
 * 
 */
public class Street
{
	public long _id;
	public ArrayList<Pair<Node,Double>> _nodes = new ArrayList<Pair<Node,Double>>();

	/**
	 * Erstellt eine Strae mit der straenid und einer Liste an Knoten.
	 * 
	 * @param straenid
	 * @param nodes
	 */
	public Street(long straenid, ArrayList<Pair<Node,Double>> nodes)
	{
		_id = straenid;
		_nodes = nodes;

	}

	/**
	 * Sucht den nchsten Knoten der Strae heraus.
	 * 
	 * @param autolnge
	 */
	public Pair<Node,Double> groerKnoten(double autolaenge)
	{
		double laenge = _nodes.get(0).getRight();
		int i = 0;
		while ((laenge < autolaenge) && (i < _nodes.size()))
		{
			i = i + 1;
			laenge = _nodes.get(i).getRight();

		}
		return _nodes.get(i);
	}

	/**
	 * Sucht den vorherigen Knoten der Strae heraus. 
	 * @param autolaenge
	 * @return
	 */
	public Pair<Node,Double> kleinerKnoten(double autolaenge)
	{
		double laenge = _nodes.get(0).getRight();
		int i = 0;
		while ((laenge < autolaenge) && (i < _nodes.size()))
		{
			i = i + 1;
			laenge = _nodes.get(i).getRight();

		}
		if (i > 0)
		{
			return _nodes.get(i - 1);
		} else
		{
			return _nodes.get(0);
		}
	}
}
