#-*- coding:utf-8 -*-
import util, math, copy, model, itertools
from collections import Counter
import xml.etree.cElementTree as ET

class way:
    """
    Straße
    """
    def __init__(self, id):
        self.id = id
        self.nodes = []#Liste mit Knoten, bei der die Straße vorbeiführt
        self.intersections  = [] #liste mit intersections die an der straße liegen
        self.type = "unclassified" #standartstraßentyp
        self.name = "Namenlos"
        self.oneway = "No"
        self.speed = 50 # Standartlgeschwindigkeit
        self.lines = 1
        self.distances = []

    def __int__(self):
        return self.id

    def __str__(self):
        string = str(self.id) + ";" + "Kein Name" + ";" + self.type + ";" + \
        str(self.oneway) + ";" + str(self.speed) + ";" + str(self.lines) + ";" + \
        str(sum(self.distances)) + ";"

        n_output = False # nodes anstatt intersections ausgeben
        if n_output == True:
            for node in self.nodes:
                string += str(node.shortid) + ":"
        else:
            for inter in self.intersections:
                string += str(util.NODE_LIST[inter.node].shortid) + ":"

        return string
    def get_et(self, root):
        way = ET.SubElement(root, "way")
        id = ET.SubElement(way, "id")
        id.text = str(self.id)
        name = ET.SubElement(way, "Name")
        name.text = str(self.name).decode('utf-8')
        typ = ET.SubElement(way, "Type")
        typ.text = str(self.type)
        nodes = ET.SubElement(way, "Nodes")

        dist = 0
        n = 0
        for node in self.nodes:
            dist += self.distances[n]
            n += 1
            xnode = ET.SubElement(nodes, "Node")
            xnode.set("id", str(node.shortid))
            xnode.text = str(dist)






    def __lt__(self, other):
        return self.name < other.name

    def checkroundabout(self):
        if self.nodes[0] == self.nodes[-1] and sum(self.distances) < 150 and len(self.nodes) > 6:
            self.type = "roundabout"
            self.oneway = "Forward"
            self.speed = 25


    def splitten(self, splitter, allnodes, waylist):


        new_nodes = []
        new_intersections =[]

        #kopf und schwanz abschneiden
        head_node = self.nodes[0]
        head_inter = self.intersections[0]


        tail_node = self.nodes[-1]
        tail_inter = self.intersections[-1]

        self.intersections.pop()
        self.intersections.pop(0)
        self.nodes.pop()
        self.nodes.pop(0)



        grenze = self.intersections.index(splitter)

        new_intersections = self.intersections[grenze:]
        self.intersections = self.intersections[:grenze+1]

        try:
            grenze = self.nodes.index(allnodes[splitter.node])
            if self.id == 248459054: print "schon vorher"
        except ValueError:
            print "ValueError:\n"+ str(head_inter.node) + "," + str(self.intersections[0].node) + ","  + str(tail_inter.node) \
            + "\n" + str(head_node.id) + "," + str(self.nodes[0].id) + "," + str(head_node.id) \
            + "\n" + str([splitter.node]) \
            + "\n" + str(self.id)
            print grenze

            #grenze = 0
        new_nodes = self.nodes[grenze:]
        self.nodes = self.nodes[:grenze+1]

        new_way = copy.copy(self)
        util.split_counter +=1
        if "000" in str(self.id):
            tmpid = int(str(self.id).split("000")[0])
        else:
            tmpid = self.id

        new_way.id = int(str(tmpid) + "000" + str(util.split_counter))
        new_way.intersections = new_intersections
        new_way.nodes = new_nodes

        self.nodes.insert(0,head_node)
        self.intersections.insert(0,head_inter)
        new_way.nodes.append(tail_node)
        new_way.intersections.append(tail_inter)

        for intersection in new_way.intersections[1:]:
            intersection.ways.remove(self)
            intersection.ways.append(new_way)

        new_way.intersections[0].ways.append(new_way)


        return new_way



    def fuseable(self, other):
        """
        Gibt True zurück,wenn es ok ist die Objekte zu fusionieren
        """
        self.nodes[-1] == other.nodes[0] \
        and self.type == other.type \
        and self.speed == other.speed \
        and self.lines == other.lines \
        and self.oneway == other.oneway


    def hasNoName(self):
        return self.name == "Namenlos"

    def add_node(self, node):
        self.nodes.append(node)

    def add_nodes(self, nodes):
        self.nodes.extend(nodes)

    def make_distances(self):
        first_node = True
        for node in self.nodes:
            if first_node:
                first_node = False
                self.distances = [0]
            else:
                self.distances.append(util.node_distance(pre_node,node))
            pre_node = node

class node:
    """
    Wegpunkt mit kooridnaten
    """
    def __init__(self, id, x , y):
        self.id = id
        self.x = x
        self.y = y
        self.shortid = None

    def __eq__(self, other):
        return self.id == other.id

    def __str__(self):
        return str(self.shortid) + ";" + str(self.x) + ";" + str(self.y)

class intersection:
    """
    Kreuzung
    """
    def __init__(self, node):
        self.node = node#id des betreffenden Knotens
        self.ways = [] #liste von wegen (später sortiert gegen den um uhrzeigersinn um die kreuzung)
        self.trafficsignal = []
        self.spawner = False
        self.rights = {} #weg von dem ich komme: weg zu dem ich will: [liste von wegen die er vorlassen muss]

    def __len__(self):
        return len(self.ways)

    def __str__(self):
        string = str(util.NODE_LIST[self.node].shortid) + ";"
        for t in self.trafficsignal:
            string += str(t.id) + ":"
        string += ";" + str(self.spawner) + ";"
        for way in self.ways: string += str(int(way)) + ":"
        string += ";"
        #...:;:von_1[:nach_1,muss_vorlassen_1,muss_vorlassen_n:nach_n,muss_vorlassen_x,]von_n[:nach_x,muss_....
        for von in self.rights:
            string += str(von.id) + "["
            for nach in self.rights[von]:
                string += str(nach.id) + ","
                for vorlassen in self.rights[von][nach]:
                    string += str(vorlassen.id) + ","
                string += ";"
            string += "]"

        return string

    def add_way(self, way):
        self.ways.append(way)

    def add_ways(self, ways):
        self.ways.extend(ways)

    def get_ways(self):
        return self.ways

    def split_all(self, allnodes, waylist):
        if len(self.ways) > 1 or len(self.trafficsignal) > 0:
            for way in self.ways:

                if self in way.intersections[1:-1]:
                    new_way = way.splitten(self, allnodes, waylist)

                    if new_way != None:
                        waylist.append(new_way)
                    else:
                        print way.id
                elif allnodes[self.node] in way.nodes[1:-1]:
                    #print str(len(way.nodes))
                    index_begin = way.nodes.index(allnodes[way.intersections[0].node])
                    index_end = way.nodes.index(allnodes[way.intersections[-1].node])
                    way.nodes = way.nodes[index_begin:(index_end+1)]
                    #print str(len(way.nodes))

    def make_right(self,  allnodes, waylist):

        r = lambda w1, wx: util.schnittwinkel_360(w1,allnodes[self.node],wx,allnodes[self.node])

        wtn = lambda way: (way.nodes[1] if way.intersections[0] == self else way.nodes[-2])



        b = lambda w1,wx,gr: abs(r(wtn(w1),wtn(wx)) - gr) < 45

        if len(self.ways) == 0:
            #print "Leere Intersection:" +  str(self.node)
            pass
        elif len(self.ways) == 1:
            self.rights[self.ways[0]] = {self.ways[0]:[]}

        elif len(self.ways) == 2:
            self.rights[self.ways[0]] = {self.ways[1]:[]}
            self.rights[self.ways[1]] = {self.ways[0]:[]}

        elif len(self.ways) == 3:
            way1 = self.ways[0]
            way2 = self.ways[1]
            way3 = self.ways[2]


            try:
                #begin sortieren
                if b(way1,way2,180) and b(way1,way3,90):
                    tmpw = self.ways.pop()
                    self.ways.insert(1,tmpw)
                elif b(way1,way2,180) and b(way1,way3,270):
                    tmpw = self.ways.pop()
                    self.ways.insert(0,tmpw)
                elif b(way1,way2,270) and b(way1,way3,180):
                    self.ways.reverse()
                elif b(way1,way2,270) and b(way1,way3,90):
                    tmpw = self.ways.pop(1)
                    self.ways.insert(0,tmpw)
                elif b(way1,way2,90) and b(way1,way3,180):
                    pass
                elif b(way1,way2,90) and b(way1,way3,270):
                    tmpw = self.ways.pop(0)
                    self.ways.append(tmpw)
                else:
                    pass
                    #print self.node
                    #print r(wtn(way1),wtn(way2))
                    #print r(wtn(way1),wtn(way3))
            except IndexError:
                print self.node
            #ende sortieren
            #print self.ways
            way1 = self.ways[0]
            way2 = self.ways[1]
            way3 = self.ways[2]

            hr =lambda x,y: util.higher_rank(x,y)
            if way1.type == way2.type and way1.type == way2.type:
                #Alle vom selben straßentyp
                self.rights[way1] = {way2:[], way3:[way2]}
                self.rights[way2] = {way1:[way3], way3:[]}
                self.rights[way3] = {way1:[], way2:[way1]}
            elif hr(way1,way2) and hr(way3,way2):
                self.rights[way1] = {way2:[], way3:[]}
                self.rights[way2] = {way1:[way1,way3], way3:[way1]}
                self.rights[way3] = {way1:[], way2:[way1]}
            elif hr(way1,way3) and hr(way2,way3):
                self.rights[way1] = {way2:[], way3:[way2]}
                self.rights[way2] = {way1:[], way3:[]}
                self.rights[way3] = {way1:[way2], way2:[way1,way2]}
            elif hr(way2, way1) and hr(way3,way1):
                self.rights[way1] = {way2:[way3], way3:[way3,way2]}
                self.rights[way2] = {way1:[way3], way3:[]}
                self.rights[way3] = {way1:[], way2:[]}
            else:
                #rechts vor links
                self.rights[way1] = {way2:[], way3:[way2]}
                self.rights[way2] = {way1:[way3], way3:[]}
                self.rights[way3] = {way1:[], way2:[way1]}


        else:

            #andere anzahl von wegen
            try:
                way1 = self.ways[0]
            except IndexError:
                print "IndexError"
                print "Ways:" + str(self.ways)
                print "ID:" + str(self.node)
            #sortieren der wege
            self.ways.sort(key=lambda x: r(wtn(way1),wtn(x)))

            if [x.type for x in self.ways].count(way1.type) == len(self.ways):
                #alle die selben rechte
                for way in self.ways:
                    self.rights[way] = {}
                    waylist = []
                    for y in range(len(self.ways)-1):
                        x= y + self.ways.index(way)+1
                        self.rights[way][self.ways[x % len(self.ways)]] = waylist
                        waylist.append(self.ways[x % len(self.ways)])
            else:

                #wenn nicht abgefangen auf rechts vor links springen (sollte mit der zeit weniger werden, wenn alle fälle richtig bearbeitet werden
                for way in self.ways:
                    self.rights[way] = {}
                    waylist = []
                    for y in range(len(self.ways)-1):
                        x= y + self.ways.index(way)+1
                        self.rights[way][self.ways[x % len(self.ways)]] = waylist
                        waylist.append(self.ways[x % len(self.ways)])

                permutation = filter(lambda x: x[0].type == x[1].type, itertools.combinations(self.ways, 2)) #die aussuchen, die vom gleichen typ sind

                ordnung = ["roundabout", "motorway", "motorway_link", "primary", "secondary", "tertiary", "residential", "living_street", "unclassified"]

                try:
                    permutation.sort(key=lambda x:ordnung.index(x[0].type))#die wichtigen nach vorne sortieren
                except ValueError:
                    for per in permutation:
                        print per

                if len(permutation) > 1 and permutation[0][0].type != permutation[1][0].type or len(permutation) == 1:#wenn es nur ein "gewinnertupel" gibt


                    mainline = permutation[0]

                    #bei allen wegen die Hauptstraße als vorfahrende staße hinzufügen
                    #@FIXME rechtsabbieger
                    for way in self.ways:
                        for way2 in self.ways:
                            if way != way2:
                                if mainline[0] not in self.rights[way][way2] and mainline[0] != way:
                                    self.rights[way][way2].append(mainline[0])

                                if mainline[1] not in self.rights[way][way2] and mainline[1] != way:
                                    self.rights[way][way2].append(mainline[1])

                    #bei de hauptstaße muss nicht gewartet werden
                    self.rights[mainline[0]][mainline[1]] = [mainline[1]]
                    self.rights[mainline[1]][mainline[0]] = [mainline[0]]

class crossroad:
    """
    Mehere Intersections, die ein Ampelcluster bilden

    """
    def __init__(self, signals):
        self.signals = signals #intersections mit Ampeln
        self.count = len(signals)

    def __eq__(self,other):
        if self.count != other.count:
            return False

        for signal in self.signals:
            if signal not in other.signals:
                return False

        return True

    def __hash__(self):
        count = self.count
        for signal in self.signals:
            count += signal.node
        return count

    def __str__(self):
        string = ""
        for inter in self.signals:
            string += str(util.NODE_LIST[inter.node].shortid)
            for t in inter.trafficsignal:
                string += "," + str(t.id)
            string +=  ":"
        return string

    def order(self, nodes):
        self.count = len(self.signals)
        if self.count == 1:
            #NUr eine Ampel im cluster (kein Problem)
            pass
        elif self.count == 2:
            #2 Ampeln im cluster (auc hkein Problem)
            pass
        elif self.count == 3:
            #3 Ampeln... ?
            streetnodes = []#Anfangs und Endknoten der Straßen an der Crossroad
            for inter in self.signals:
                for way in inter.ways:
                    streetnodes.extend([way.intersections[0],way.intersections[-1]])

            #print streetnodes
            center = Counter(streetnodes).most_common(1)[0][0]

            winkel = util.schnittwinkel_360(\
                nodes[self.signals[0].node],\
                nodes[center.node],\
                nodes[self.signals[1].node],\
                nodes[center.node])
            runs = 0
            while winkel > 200 or winkel < 160 : #nicht gengenüber
                runs +=1
                if runs == 3: break
                #rotieren
                #print winkel
                temp = self.signals[2]
                self.signals[2] = self.signals[1]
                self.signals[1] = self.signals[0]
                self.signals[0] = temp

                winkel = util.schnittwinkel_360(\
                nodes[self.signals[0].node],\
                nodes[center.node],\
                nodes[self.signals[1].node],\
                nodes[center.node])

            #print winkel
            #print center.node



        elif self.count == 4:
            """
            Sorgt dafür, dass [0] und [1] de eine straße und [2] und [3] die andere straße sind
            """
            winkel = util.schnittwinkel_360(\
            nodes[self.signals[0].node],\
            nodes[self.signals[1].node],\
            nodes[self.signals[2].node],\
            nodes[self.signals[3].node])
            #print winkel
            if winkel < 45 or (winkel > 135 and winkel < 235) or winkel > 315:
                temp = self.signals[1]
                self.signals[1] = self.signals[2]
                self.signals[2] = temp
                winkel = util.schnittwinkel_360(\
                nodes[self.signals[0].node],\
                nodes[self.signals[1].node],\
                nodes[self.signals[2].node],\
                nodes[self.signals[3].node])
                #print "neu: " + str(winkel)
                if winkel < 45 or (winkel > 135 and winkel < 235) or winkel > 315:
                    temp = self.signals[1]
                    self.signals[1] = self.signals[3]
                    self.signals[3] = temp
                    #print "neu2: " + str(util.schnittwinkel_360(\
                    #nodes[self.signals[0].node],\
                    #nodes[self.signals[1].node],\
                    #nodes[self.signals[2].node],\
                    #nodes[self.signals[3].node]))
            #print "####"

        else:
            pass


class spawner:
    """
    Spawner für die Autos,
    Das heißt nuntzungsfälchen bei denen autos gespawnt oder despawnt werden.

    """
    def __init__(self, id, type, nodes):
        self.id = id # Die id des Spawners
        self.type = type #Büro, wohngebiet etc.
        self.nodes = nodes #Liste von knoten die das Gebiet umreißen
        self.inside = []
        self.spawnpoints = [] # PUnkte an denen gespawnt wird
        self.area = 0 # Größe des gebietes in m^2

    def __str__(self):
        return None

    def string(self, intersections):
        string = str(self.id) + ";" + self.type + ";" + str(self.area) + ";"
        try:
            for point in set(points.id for points in self.spawnpoints):
                string += str(util.NODE_LIST[point].shortid)
                string += "," + str(intersections[point].ways[0].id)

                string += ":"
        except IndexError:
            print intersections[point]
            print intersections[point].ways
        return string


    def get_points(self, x_nodes, intersections):
        """
        holt sich alle Punkte im Spawner
        """
        polygon = []
        for waypoint in self.nodes:
            polygon.append((waypoint.x, waypoint.y))
        point = polygon[0]

        pointxup = point[0] + 0.008
        pointxdown = point[0] - 0.008
        pointyup = point[1] + 0.008
        pointydown = point[1] - 0.008
        #x_list = filter(lambda x: x > (point[0] - 0.006) and x < (point[0] + 0.006) ,nodes_x.iterkeys())

        #y_list = filter(lambda y: y > (point[1] - 0.006) and y < (point[1] + 0.006) ,nodes_y.iterkeys())

        #nodelist = filter(lambda node: node.x > pointxdown and node.x < pointxup and node.y > pointydown and node.y < pointyup, allnodes.values())
        #opt float() + allnodes zu liste um schneller drüber iterieren zu können ?


        nodelist = []

        for node in x_nodes:
            if node.x > pointxup:
                break
            if node.x > pointxdown and node.y > pointydown and node.y < pointyup:
                nodelist.append(node)




        #print len(nodelist)
        for node in nodelist:
            inside = util.point_inside_polygon(node.x,node.y,polygon)

            if inside:
                self.inside.append(node)
        #print self.inside

        for node in self.inside:
            if node.id in intersections:
                self.spawnpoints.append(node)
                intersections[node.id].spawner = True
        if self.spawnpoints == []:
            """
            Keine Internen Spawnpoints gefunden
            """
            nearnodes = nodelist
            for waypoint in self.nodes:
                buffer = []
                for node in nearnodes:
                    if node.id in intersections:
                        dist = util.quick_node_distance(waypoint,node)
                        if dist > 0:
                            buffer.append({"node": node, "dist":dist})



                if buffer != []:
                    mindist =min(buffer, key=lambda x:x['dist'])
                else:
                    #print "Keinen Knoten zum Gebiet gefunden"
                    mindist = None

                if mindist != None:
                    self.spawnpoints.append(mindist["node"])
                    intersections[mindist["node"].id].spawner = True

        """
        Größe Berechnen:
        """
        area = util.poly_area2D(polygon)
        area = (util.distance_on_unit_sphere(0,0,0,math.sqrt(area))* 6373 * 1000) ** 2
        self.area = area
        #print area



        while len(self.spawnpoints) > 25:
            remove = []
            for i in range(len(self.spawnpoints)):
                if (i % 2) == 0:
                    remove.append(self.spawnpoints[i])
            #print remove
            for r in remove:
                self.spawnpoints.remove(r)
                #intersections[r.id].spawner = False
        #print len(self.spawnpoints)

#class map:


