import matplotlib.pyplot as plt
import startup, os, model
import xml.etree.cElementTree as ET

plot_int = False # Kreuzungen mitplotten

class plot:
    def __init__(self, cars = False):

        self.get_infos()

        plt.figure(figsize=(23, 19),frameon=False,dpi=100,facecolor="w")
        #plt.axis([9.97335434,10.01609802,53.53653282,53.55846146])
        plt.axis('off')

        plt.grid(True)
        plt.hold(True)
        for way in self.ways:
            #print way.type
            type= way.type
            x = []
            y = []
            for node in way.nodes:

                x.append(node.x)
                y.append(node.y)

            if type == 'motorway' or type == 'motorway_link' or type == "roundabout":
                plt.plot(x,y, linestyle = 'solid', color= 'k', label='Autobahn (110)')

            elif type == 'primary':
                plt.plot(x,y, linestyle = 'solid', color= 'k', label='Ausserorts (100)')

            elif type == 'living_street' or type == 'unclassified' or type == 'residential':
                plt.plot(x,y, linestyle = 'solid', color= 'c', label='Stadt (30)')

            elif type == 'tertiary' or type == 'secondary':
                plt.plot(x,y, linestyle = 'solid', color= 'b', label='Stadt (50)')

            else:
                pass
                    #print way["type"]
                    #plt.plot(x,y, linestyle= 'dotted', color = 'm', label='nicht zugeordnet')
        #plt.legend()
        """
        for path in paths:

            x = []
            y = []
            for node in path:

                x.append(nodes[node].x)
                y.append(nodes[node].y)
                plt.plot(x,y, linestyle = 'dotted', color= 'r')
        """

        """
        for area in use:

            if area.type != []:
                x = []
                y = []
                for node in area.nodes:

                    x.append(node.x)
                    y.append(node.y)

                if area.type == 'commercial':
                    plt.fill(x,y, alpha = 0.2, color= 'r', label='Bueros')
                elif area.type == 'industrial':
                    plt.fill(x,y, alpha = 0.2, color= 'k', label='Industrie')
                elif area.type == 'residential':
                    plt.fill(x,y, alpha = 0.2, color= 'g', label='Wohnraum')
                elif area.type == 'retail':
                    plt.fill(x,y, alpha = 0.2, color= 'b', label='Gewerbe')
        """
            #for inside in area.spawnpoints:
            #    plt.plot(inside.x,inside.y, color='g', marker='.')

        """
        for inter in intersection.values():

            if inter.trafficsignal:
                plt.plot(nodes[int(inter.node)].x,nodes[int(inter.node)].y, color='k', marker='o')
        """

        #alle Kreuzungen Plotten
        """
        if plot_int:
            for inter in intersection.values():
                plt.plot(nodes[int(inter.node)].x,nodes[int(inter.node)].y, color='k', marker='o')

        for crossroad in crossroads:
            if crossroad.count == 4:
                plt.plot([nodes[crossroad.signals[0].node].x,nodes[crossroad.signals[1].node].x],\
                [nodes[crossroad.signals[0].node].y,nodes[crossroad.signals[1].node].y], linestyle = 'solid', color= 'r')

                plt.plot([nodes[crossroad.signals[2].node].x,nodes[crossroad.signals[3].node].x],\
                [nodes[crossroad.signals[2].node].y,nodes[crossroad.signals[3].node].y], linestyle = 'solid', color= 'y')


            else:
                x = []
                y = []
                for inter in crossroad.signals:
                    x.append(nodes[int(inter.node)].x)
                    y.append(nodes[int(inter.node)].y)

                plt.plot(x,y, linestyle = 'solid', color= 'k')
        """
        #plt.plot(nodes[300077351].x,nodes[300077351].y, color='k', marker='*')

        if cars:
            carfile = open("input/ausgabe_"+startup.FILE+".dat", "r")
            thiscars = []
            i = 0
            for line in carfile:
                if ";" in line:
                    coor = line.split(";")
                    thiscars.append((float(coor[0]), float(coor[1][:-2])))
                else:
                    i += 1
                    points = []
                    if i > 0:
                        for carplace in thiscars:
                            points.append(plt.plot(carplace[0], carplace[1], color='r', marker='.'))
                        
                        #plt.xlim(9.97335434,10.01609802)
                        plt.savefig("images/output" + str(i).zfill(4) + ".png",bbox_inches='tight')
                        for point in points:
                            point[0].remove()
                    thiscars = []

        else:

            plt.show()


    def get_infos(self):


        baseDir = "output/" + startup.FILE + "/"
        if(not(os.path.isdir(baseDir))):
            os.mkdir(baseDir)

        self.nodes = {}
        for line in open(baseDir + "nodes_"+ startup.FILE +"_tmp.dat", "r"):
            if ";" in line:
                values = line.split(";")
                node = model.node(int(values[0]), float(values[1]), float(values[2]))
                self.nodes[int(values[0])] = node

        self.ways = []
        """
        for line in open(baseDir + "ways_"+ startup.FILE +"_tmp.dat", "r"):
            if ";" in line:
                values = line.split(";")
                way = model.way(values[0])
                way.type = values[2]
                nodes = values[-1].split(":")
                for node in nodes[:-1]:
                    #print node
                    way.nodes.append(self.nodes[int(node)])
                self.ways.append(way)
        """
        tree = ET.parse(baseDir + "fullways_"+ startup.FILE +"_tmp.xml")
        root = tree.getroot()
        for xway in root:
            id = int(xway.find("id").text)
            type = xway.find("Type").text
            way = model.way(id)
            way.type = type
            for xnode in xway.find("Nodes"):
                nnode = xnode.get("id")
                way.nodes.append(self.nodes[int(nnode)])
            self.ways.append(way)




if __name__ == '__main__':
    plot(cars=True)
