/*
Serial traffic simulation program for PaPo.

############################################

This application uses data from Open Street Map, henceforth
that data is made available under the Open Database License: http://opendatacommons.org/licenses/odbl/1.0/.
Any rights in individual contents ofthe database are licensed under 
the Database Contents License: http://opendatacommons.org/licenses/dbcl/1.0/
See more at: http://opendatacommons.org/licenses/odbl/#sthash.y0L9Yy1N.dpuf

############################################

Author: Martin Poppinga, Miriam von Heeremann, Marcel Ellermann
Date: 24.07.2013      
Distributed under the Boost Software License, Version 1.0.
See accompanying file LICENSE_1_0.txt or copy at
http://www.boost.org/LICENSE_1_0.txt)

#############################################
*/

#pragma once

#include "boost/cstdint.hpp"
#include "worldDefs.h"
#include <map>
#include <string.h>

using namespace boost;

namespace traffic_simulation
{

	class ConfigHandler
	{
	public:

		static ConfigHandler* getInstance();
		static bool loaded(){return _bLoaded;};

		double getDouble(std::string v);
		std::string getPath(std::string v);
		ui16 getUInt16(std::string v);
		ui32 getUInt32(std::string v);
		ui64 getUInt64(std::string v);
		bool getBool(std::string v);

		~ConfigHandler();
	private:
		ConfigHandler();
		bool loadConfigFile();
		std::map<std::string, std::string> _confValues;
		static ConfigHandler* _instance;
		static bool _bInstance;
		static bool _bLoaded;
	};
}