#include <stdint.h>
#include <stdio.h>
#include <iostream>
#include <sstream>
#include <string.h>
#include <omp.h>
#include <mpi.h>
#include "Messages.h"
#include "MessageHandler.h"

int main(int arg, char** argv)
{
#ifdef ENABLE_NESTED
	std::cout << "Nested Prallelisim enabled" << std::endl;
#else
	std::cout << "Nested parallelism not enabled" << std::endl;
#endif
	int ierror;
	MPI_Init_thread(&arg, &argv, MPI_THREAD_SERIALIZED, &ierror);
	int Rank;
	//_sleep(10000);
	std::cout << ierror << std::endl;
	MPI_Comm_rank(MPI_COMM_WORLD, &Rank);
	std::cout << Rank << std::endl;
	MessageHandler::Init();
#pragma omp parallel sections shared(Rank)
	{
#pragma omp section 
		{
			MPIRcvMessage_Car _carMsg;
			_carMsg.registerSelf(&_carMsg);
//			MPIRcvMessage_CtoE _closetoendmsg;
//			MPIRcvMessage_NCtoE _nctoeMsg;
//			MPIRcvMessage_CtoB _ctobMsg;
//			MPIRcvMessage_NCtoB _nctobMsg;
			MessageHandler::getInstance()->RunRcvManager();
		}
#pragma omp section
		{
			MessageHandler::getInstance()->WaitTillReadyForRcv();
			for(int i = 0; i < 100; i++)
			{
				__carStoreStruct car;
				car._guid = i;
				MessageHandler::getInstance()->SendMessage(&car, 1, MSG_CAR, Rank == 0 ? 1 : 0);
			}
			std::cout << "Waiting for all sends to be finished.." << std::endl;
			MessageHandler::getInstance()->WaitMsgsSend();
			std::cout << "All Messages have been send" << std::endl;
			MPI_Barrier(MPI_COMM_WORLD);
//			_sleep(2000);
			MessageHandler::getInstance()->FinalizeHandler();
		}
	}
	std::string s;
	std::getline(std::cin, s);
	MPI_Barrier(MPI_COMM_WORLD);
	MPI_Finalize();
	return 0;
}
