/*
	Serial traffic simulation program for PaPo.

	############################################

	This application uses data from Open Street Map, henceforth
	that data is made available under the Open Database License: http://opendatacommons.org/licenses/odbl/1.0/.
	Any rights in individual contents ofthe database are licensed under 
	the Database Contents License: http://opendatacommons.org/licenses/dbcl/1.0/
	See more at: http://opendatacommons.org/licenses/odbl/#sthash.y0L9Yy1N.dpuf

	############################################

	Author: Martin Poppinga, Miriam von Heeremann, Marcel Ellermann
	Date: 24.07.2013      
	Distributed under the Boost Software License, Version 1.0.
	    See accompanying file LICENSE_1_0.txt or copy at
	          http://www.boost.org/LICENSE_1_0.txt)

	#############################################
*/
#pragma once

#include "boost/cstdint.hpp"
#include <sstream>

namespace traffic_simulation
{
	class world
	{
	public:
		~world();
		
		static world* getInstance();

		void update(boost::uint8_t step = 1);
		static int getCommRank();
		static int getCommSize();
		static bool loaded(){return _bLoaded;};
		static boost::uint32_t getTimeStamp(){return _lTimeStamp;};
		static std::string getInputFile(char fileType);
	private:
		world();

		static int _rank;
		static int _size;

		static std::string _fileName;
		static world* _instance;
		static bool   _bInstance;
		static bool   _bLoaded;
		static boost::uint32_t _lTimeStamp; //logical time stamp to represent worlds internal time
	};
}