import java.util.ArrayList;

/**
 * Strae mit Straenid und eine Liste von Knoten, die jeweils den Abstand zum 0
 * Knoten haben.
 * 
 * @author Miriam von Heereman, Marcel Ellermann, Martin Poppinga
 * 
 */
public class Street
{
	public long _id;
	public ArrayList<Node> _nodes = new ArrayList<Node>();

	/**
	 * Erstellt eine Strae mit der straenid und einer Liste an Knoten.
	 * 
	 * @param straenid
	 * @param nodes
	 */
	public Street(long straenid, ArrayList<Node> nodes)
	{
		_id = straenid;
		_nodes = nodes;

	}

	/**
	 * Fragt ab ob die bergebene straenid mit der der Strae bereinstimmt.
	 * 
	 * @param straenid
	 * @return
	 */
	public boolean idAbfrage(long straenid)
	{
		if (straenid == _id)
		{
			return true;
		} else
		{
			return false;
		}
	}

	/**
	 * Sucht den nchsten Knoten der Strae heraus.
	 * 
	 * @param autolnge
	 */
	public Node groerKnoten(double autolaenge)
	{
		double laenge = _nodes.get(0).laengenAbfrage();
		int i = 0;
		while ((laenge < autolaenge) && (i < _nodes.size()))
		{
			i = i + 1;
			laenge = _nodes.get(i).laengenAbfrage();

		}
		return _nodes.get(i);
	}

	/**
	 * Sucht den vorherigen Knoten der Strae heraus. 
	 * @param autolaenge
	 * @return
	 */
	public Node kleinerKnoten(double autolaenge)
	{
		double laenge = _nodes.get(0).laengenAbfrage();
		int i = 0;
		while ((laenge < autolaenge) && (i < _nodes.size()))
		{
			i = i + 1;
			laenge = _nodes.get(i).laengenAbfrage();

		}
		if (i > 0)
		{
			return _nodes.get(i - 1);
		} else
		{
			return _nodes.get(0);
		}
	}
}
